local bump = require "bump/bump"
anim8 = require "anim8/anim8"
local camera = require "gamera/gamera"
love.graphics.setDefaultFilter("nearest", "nearest")
require("player")
--local coins = {}
require("coin")
coinSprite = love.graphics.newImage("Sprites/goldcoin.png")
local STI = require("sti")
level = require("Map/testMap")

function levelLoader(level)
    Map = STI(level)
    local objects = level.layers["solids"].objects
    for i = 1, #objects do
        local obj = objects[i]
        obj.isWall = true
        world:add(obj, obj.x, obj.y, obj.width, obj.height)
    end
end

--spawns coins
--[[
function coinSpawner()
    coin = coins
    goldCoin = coinSprite
    coinGrid = anim8.newGrid(8, 8, goldCoin:getWidth(), goldCoin:getHeight())
    local location = level.layers["coinspawn"].objects
    for i = 1, #location do
        local inst = location[i]
        coin[i] = {
            x = inst.x + 8,
            y = inst.y + 8,
            w = 8,
            h = 8,
            anim = anim8.newAnimation(coinGrid("1-6", 1), 0.1),
            index = i,
            isCoin = true
        }
        world:add(coin[i], coin[i].x - coin[i].w * 0.5, coin[i].y - coin[i].h, coin[i].w, coin[i].h)
    end
end
--]]

function love.load()
    world = bump.newWorld()
    Player:load()
    levelLoader(level)
    --coinSpawner()
    Coin:spawner()
    cam = camera.new(0, 0, Map.width * Map.tilewidth, Map.height * Map.tileheight)
    cam:setScale(2.0)
end

function love.update(dt)
    Player:update(dt)
    --camera updater    
    cam:setPosition(Player.x, Player.y)
    --coinAnim:update(dt)
    Coin:updater(dt)
    --[[
    for i, value in pairs(coin) do
        if coin[i] ~= nil then
            coin[i].anim:update(dt)
        end
    end
    ]]

    --coinUpdater(dt)
    
    --print(Player.yVel)
end

function love.draw()
    cam:draw(function()
        Map:drawLayer(Map.layers["tiles"])
        --currAnim:draw(Player.img, Player.x, Player.y, nil, Player.factor * Player.zoom, Player.zoom, 4, 8)
        Player:draw()
        Coin:draw()
        --[[
        for i, value in pairs(coin) do
            if coin[i] ~= nil then
                coin[i].anim:draw(goldCoin, coin[i].x, coin[i].y, nil, 1, 1, 4, 8)
            end
        end
        ]]

        --drawCoins()
    end)
end 